> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/compute-services/compute-engine/cloud-gpu-vm/api-how-tos/retrieve-template-list.md).

# Retrieve Template list

You can retrieve a list of configuration templates that are currently available. Instances have a fixed configuration of vCPU, RAM, and direct-attached storage size.

## Endpoint

Use the following endpoint for templates: `https://api.ionos.com/cloudapi/v6/templates/?depth=3` The depth parameter will expand the response payload so you can process the payload across all templates and identify the needed templates for your use case.

{% hint style="info" %}
**Note:** The list contains templates for Cubes as well as GPU instances. We recommend checking the naming convention to confirm the instance type the template is intended for.
{% endhint %}

## Request

{% hint style="info" %}
**Note:** The following request contains sample values. Remember to replace them with the relevant information.
{% endhint %}

```bash
curl --location \
--request GET 'https://api.ionos.com/cloudapi/v6/templates/?depth=3' \
--header 'Authorization: Bearer eyJ0eXAiOiJKV1QiLCJraWQiO' \
--header 'Content-Type: application/json'
```

{% tabs %}
{% tab title="Path Parameters" %}
To make authenticated requests to the API, the following fields are mandatory in the request header:

| **Name**     | **Type** | **Description**                                          |
| ------------ | -------- | -------------------------------------------------------- |
| `v6`         | string   | The API version.                                         |
| `templates`  | string   | Template attributes: `ID`, `metadata`, and `properties`. |
| {% endtab %} |          |                                                          |

{% tab title="Query Parameters" %}
You can refine your request by adding the optional query parameter `depth`.

| **Name**      | **Type** | **Description**                              |
| ------------- | -------- | -------------------------------------------- |
| `depth`       | integer  | Template detail depth. Default value is `0`. |
| {% endtab %}  |          |                                              |
| {% endtabs %} |          |                                              |

## Response

A **200** message confirms that the templates list is fetched. The response will contain multiple templates,each in the format shown in the response example.

```json
{
			"id": "e15d15e7-ea9a-48ae-a60a-29b9463f4519",
			"type": "template",
			"href": "https://api.ionos.com/cloudapi/v6/templates/e15d15e7-ea9a-48ae-a60a-29b9463f4519",
			"metadata": {
				"etag": "5e91ac6d46fc3e1da0c0cf6353bc9576",
				"createdDate": "2025-10-16T08:41:00Z",
				"createdBy": "[UNKNOWN]",
				"createdByUserId": "[UNKNOWN]",
				"lastModifiedDate": "2025-12-03T10:54:36Z",
				"lastModifiedBy": "[UNKNOWN]",
				"lastModifiedByUserId": "[UNKNOWN]",
				"state": "AVAILABLE"
			},
			"properties": {
				"name": "H200-S",
				"cores": 15,
				"ram": 273408,
				"storageSize": 1000,
				"storageType": "Performance",
				"category": "GPU Category",
				"gpus": [
					{
						"vendor": "NVIDIA Corporation",
						"model": "GH100 [H200 NVL]",
						"type": "passthrough",
						"count": 1
					}
				]
			}
		}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.ionos.com/cloud/compute-services/compute-engine/cloud-gpu-vm/api-how-tos/retrieve-template-list.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
